*:*****************************************************************************
*:
*: Procedure file: DEFAULT.PRG
*:
*:         System: Select your default path by point and shoot.
*:                 This .PRG will define a popup list based on:
*:                 IF a *.DBF exists in a directory anywhere on disk.
*:
*:          Notes: You will need to edit the hard coded paths
*:                 if you have installed Foxpro 2.5 in any
*:                 drive or path other that the default installation
*:                 paths created by FoxPro 2.5.
*:
*:  Suggested Use: Add a line in your CONFIG.FP
*:                 COMMAND = DO DEFAULT
*:
*:         Author: Claude Sterling McVea  CIS: 70033,2274
*:
*:   Incidentally: I am seeking employment in or around 
*:                 Huntington Beach, California.  
*:                 I have extensive experience in technical 
*:                 support and customer support for Banking 
*:                 applications.  I am currently employed by 
*:                 a firm who uses C language databases and 
*:                 C language applications and I would like 
*:                 to join a firm who could use my talents, 
*:                 but, in a FoxPro world.
*:
*:      Copyright: Released to Public Domain
*:  Last modified: 07/05/93     17:25
*:
*:  Procs & Fncts: DEFAULT
*:               : MYDEFAULT
*:               : GET_FILES
*:
*:      Documented 07/05/93 at 17:26               FoxDoc  version 2.10f
*:*****************************************************************************
*!*****************************************************************
*!
*!      Procedure: DEFAULT
*!
*!*****************************************************************
PROCEDURE DEFAULT
   parameter passed_parameter

   IF SET('TALK') = 'ON'
      SET TALK OFF
      savetalk = 'ON'
   ELSE
      savetalk = 'OFF'
   ENDIF

   IF PARAMETERS() = 0
      passed_parameter = 'FULL'
   ENDIF

   DO get_files

   SELECT DISTINCT *;
      FROM DEFAULT;
      INTO CURSOR default_

*   DEFINE POPUP DEFAULT ;
*      FROM 00,00 TO 24,79 ;
*      PROMPT FIELD pathname ;
*      TITLE "Select Path"
   ON SELECTION POPUP DEFAULT ;
      DO mydefault WITH PROMPT()
   ACTIVATE POPUP DEFAULT

   RELEASE POPUP DEFAULT EXTENDED
   CLOSE DATABASES

   WAIT WINDOW NOWAIT 'Default path is set to: ' + SYS(5)+SYS(2003)

*!*****************************************************************
*!
*!      Procedure: MYDEFAULT
*!
*!*****************************************************************
PROCEDURE mydefault
   parameter prompted

   SET DEFAULT TO &prompted
   DEACTIVATE POPUP DEFAULT
   
   SET TALK &savetalk      && Restore original setting

   RETURN

*!*****************************************************************
*!
*!      Procedure: GET_FILES
*!
*!*****************************************************************
PROCEDURE get_files
   IF _dos
      SET LIBRARY TO c:\foxpro25\foxapp\libs\fpath
      DEFINE POPUP DEFAULT ;
	      FROM 00,00 to 24,79 ;
    	  PROMPT FIELD pathname ;
 		  TITLE "Select Path"
   ENDIF

   IF _windows
      SET LIBRARY TO c:\foxprow\foxtools
      DEFINE POPUP DEFAULT ;
	      FROM 00,00 to 50,79 ;
    	  PROMPT FIELD pathname ;
 		  TITLE "Select Path"

   ENDIF
   tempfile = SYS(2023)+SYS(3)+'.TMP'
   RUN c:\foxpro25\goodies\misc\fls /s c:\*.dbf > &tempfile
   IF FILE("D:\nul")  && Do this for every drive on your system
      RUN c:\foxpro25\goodies\misc\fls /s d:\*.dbf >> &tempfile
   ENDIF
   CREATE CURSOR DEFAULT (pathname C(129))
   APPEND FROM (tempfile) DELIMITED
   ERASE (tempfile)
   ** -------------------------------------------------------------
   ** Now you have your choice of all the paths or a shorter path
   ** You can call this with 'FULL' parameter or no parameter
   **  Just change the CONFIG.FP to COMMAND = DO DEFAULT with 'SHORT'
   **

   IF passed_parameter == 'FULL'
      REPLACE ALL default.pathname WITH justpath(default.pathname)
   ELSE
      REPLACE ALL default.pathname WITH ;
         SUBSTR(justpath(default.pathname),1,AT('\',default.pathname,2))
      GO TOP
      DO WHILE NOT EOF()
         IF RAT('\',pathname) > 3
            REPLACE default.pathname WITH ;
               SUBSTR(default.pathname,1,RAT('\',default.pathname)-1)
         ENDIF
         SKIP
      ENDDO
   ENDIF
   IF _dos
      RELEASE LIBRARY fpath
   ENDIF
   IF _windows
      RELEASE LIBRARY foxtools
   ENDIF
   RETURN

*: EOF: DEFAULT.PRG
